// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package bonding

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
	_ = abi.ConvertType
)

// BondingData is an auto generated low-level Go binding around an user-defined struct.
type BondingData struct {
	Token       common.Address
	Name        string
	Name0       string
	Ticker      string
	Supply      *big.Int
	Price       *big.Int
	MarketCap   *big.Int
	Liquidity   *big.Int
	Volume      *big.Int
	Volume24H   *big.Int
	PrevPrice   *big.Int
	LastUpdated *big.Int
}

// BondingMetaData contains all meta data concerning the Bonding contract.
var BondingMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"inputs\":[],\"name\":\"InvalidInitialization\",\"type\":\"error\"},{\"inputs\":[],\"name\":\"NotInitializing\",\"type\":\"error\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"}],\"name\":\"OwnableInvalidOwner\",\"type\":\"error\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"OwnableUnauthorizedAccount\",\"type\":\"error\"},{\"inputs\":[],\"name\":\"ReentrancyGuardReentrantCall\",\"type\":\"error\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"SafeERC20FailedOperation\",\"type\":\"error\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"univ2Pair\",\"type\":\"address\"}],\"name\":\"Graduated\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint64\",\"name\":\"version\",\"type\":\"uint64\"}],\"name\":\"Initialized\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"pair\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"Launched\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"sender\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"amount0In\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"amount0Out\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"amount1In\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"amount1Out\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"reserve0\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"reserve1\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"volume\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"volume24H\",\"type\":\"uint256\"}],\"name\":\"Swap\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"address\",\"name\":\"addedPool\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"idx\",\"type\":\"uint256\"}],\"name\":\"UniswapPoolCreated\",\"type\":\"event\"},{\"inputs\":[],\"name\":\"K\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"assetRate\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"amountIn\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"tokenAddress\",\"type\":\"address\"}],\"name\":\"buy\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"payable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"factory\",\"outputs\":[{\"internalType\":\"contractFFactory\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"fee\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getUniswapPairsLength\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"getUserTokens\",\"outputs\":[{\"internalType\":\"address[]\",\"name\":\"\",\"type\":\"address[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"gradThreshold\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"initialSupply\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"factory_\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"router_\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"feeTo_\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"fee_\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"initialSupply_\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"assetRate_\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"maxTx_\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"gradThreshold_\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"uniswapV2Router_\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"lpLocker_\",\"type\":\"address\"}],\"name\":\"initialize\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_ticker\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"desc\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"img\",\"type\":\"string\"},{\"internalType\":\"string[3]\",\"name\":\"urls\",\"type\":\"string[3]\"},{\"internalType\":\"uint256\",\"name\":\"purchaseAmount\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"nftAddress\",\"type\":\"address\"}],\"name\":\"launch\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"payable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"lpLocker\",\"outputs\":[{\"internalType\":\"contractLPLocker\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"maxTx\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"profile\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"user\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"profiles\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"router\",\"outputs\":[{\"internalType\":\"contractFRouter\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"amountIn\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"tokenAddress\",\"type\":\"address\"}],\"name\":\"sell\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"newRate\",\"type\":\"uint256\"}],\"name\":\"setAssetRate\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"newFee\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"newFeeTo\",\"type\":\"address\"}],\"name\":\"setFee\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"newThreshold\",\"type\":\"uint256\"}],\"name\":\"setGradThreshold\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"newSupply\",\"type\":\"uint256\"}],\"name\":\"setInitialSupply\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"maxTx_\",\"type\":\"uint256\"}],\"name\":\"setMaxTx\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newRouter\",\"type\":\"address\"}],\"name\":\"setUniswapRouter\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"tokenInfo\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"creator\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"pair\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"nftAddress\",\"type\":\"address\"},{\"components\":[{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"string\",\"name\":\"name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"ticker\",\"type\":\"string\"},{\"internalType\":\"uint256\",\"name\":\"supply\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"price\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"marketCap\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"liquidity\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"volume\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"volume24H\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"prevPrice\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"lastUpdated\",\"type\":\"uint256\"}],\"internalType\":\"structBonding.Data\",\"name\":\"data\",\"type\":\"tuple\"},{\"internalType\":\"string\",\"name\":\"description\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"image\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"website\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"twitter\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"telegram\",\"type\":\"string\"},{\"internalType\":\"bool\",\"name\":\"trading\",\"type\":\"bool\"},{\"internalType\":\"bool\",\"name\":\"tradingOnUniswap\",\"type\":\"bool\"},{\"internalType\":\"address\",\"name\":\"uniswapV2Pair\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"tokenInfos\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"recipient\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"amount\",\"type\":\"uint256\"}],\"name\":\"transferToken\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"uniswapPairs\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"uniswapRouter\",\"outputs\":[{\"internalType\":\"contractIUniswapV2Router02\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"}]",
}

// BondingABI is the input ABI used to generate the binding from.
// Deprecated: Use BondingMetaData.ABI instead.
var BondingABI = BondingMetaData.ABI

// Bonding is an auto generated Go binding around an Ethereum contract.
type Bonding struct {
	BondingCaller     // Read-only binding to the contract
	BondingTransactor // Write-only binding to the contract
	BondingFilterer   // Log filterer for contract events
}

// BondingCaller is an auto generated read-only Go binding around an Ethereum contract.
type BondingCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// BondingTransactor is an auto generated write-only Go binding around an Ethereum contract.
type BondingTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// BondingFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type BondingFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// BondingSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type BondingSession struct {
	Contract     *Bonding          // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// BondingCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type BondingCallerSession struct {
	Contract *BondingCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts  // Call options to use throughout this session
}

// BondingTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type BondingTransactorSession struct {
	Contract     *BondingTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts  // Transaction auth options to use throughout this session
}

// BondingRaw is an auto generated low-level Go binding around an Ethereum contract.
type BondingRaw struct {
	Contract *Bonding // Generic contract binding to access the raw methods on
}

// BondingCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type BondingCallerRaw struct {
	Contract *BondingCaller // Generic read-only contract binding to access the raw methods on
}

// BondingTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type BondingTransactorRaw struct {
	Contract *BondingTransactor // Generic write-only contract binding to access the raw methods on
}

// NewBonding creates a new instance of Bonding, bound to a specific deployed contract.
func NewBonding(address common.Address, backend bind.ContractBackend) (*Bonding, error) {
	contract, err := bindBonding(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Bonding{BondingCaller: BondingCaller{contract: contract}, BondingTransactor: BondingTransactor{contract: contract}, BondingFilterer: BondingFilterer{contract: contract}}, nil
}

// NewBondingCaller creates a new read-only instance of Bonding, bound to a specific deployed contract.
func NewBondingCaller(address common.Address, caller bind.ContractCaller) (*BondingCaller, error) {
	contract, err := bindBonding(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &BondingCaller{contract: contract}, nil
}

// NewBondingTransactor creates a new write-only instance of Bonding, bound to a specific deployed contract.
func NewBondingTransactor(address common.Address, transactor bind.ContractTransactor) (*BondingTransactor, error) {
	contract, err := bindBonding(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &BondingTransactor{contract: contract}, nil
}

// NewBondingFilterer creates a new log filterer instance of Bonding, bound to a specific deployed contract.
func NewBondingFilterer(address common.Address, filterer bind.ContractFilterer) (*BondingFilterer, error) {
	contract, err := bindBonding(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &BondingFilterer{contract: contract}, nil
}

// bindBonding binds a generic wrapper to an already deployed contract.
func bindBonding(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := BondingMetaData.GetAbi()
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, *parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Bonding *BondingRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Bonding.Contract.BondingCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Bonding *BondingRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Bonding.Contract.BondingTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Bonding *BondingRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Bonding.Contract.BondingTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Bonding *BondingCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Bonding.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Bonding *BondingTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Bonding.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Bonding *BondingTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Bonding.Contract.contract.Transact(opts, method, params...)
}

// K is a free data retrieval call binding the contract method 0xa932492f.
//
// Solidity: function K() view returns(uint256)
func (_Bonding *BondingCaller) K(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "K")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// K is a free data retrieval call binding the contract method 0xa932492f.
//
// Solidity: function K() view returns(uint256)
func (_Bonding *BondingSession) K() (*big.Int, error) {
	return _Bonding.Contract.K(&_Bonding.CallOpts)
}

// K is a free data retrieval call binding the contract method 0xa932492f.
//
// Solidity: function K() view returns(uint256)
func (_Bonding *BondingCallerSession) K() (*big.Int, error) {
	return _Bonding.Contract.K(&_Bonding.CallOpts)
}

// AssetRate is a free data retrieval call binding the contract method 0xe8e6ed69.
//
// Solidity: function assetRate() view returns(uint256)
func (_Bonding *BondingCaller) AssetRate(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "assetRate")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// AssetRate is a free data retrieval call binding the contract method 0xe8e6ed69.
//
// Solidity: function assetRate() view returns(uint256)
func (_Bonding *BondingSession) AssetRate() (*big.Int, error) {
	return _Bonding.Contract.AssetRate(&_Bonding.CallOpts)
}

// AssetRate is a free data retrieval call binding the contract method 0xe8e6ed69.
//
// Solidity: function assetRate() view returns(uint256)
func (_Bonding *BondingCallerSession) AssetRate() (*big.Int, error) {
	return _Bonding.Contract.AssetRate(&_Bonding.CallOpts)
}

// Factory is a free data retrieval call binding the contract method 0xc45a0155.
//
// Solidity: function factory() view returns(address)
func (_Bonding *BondingCaller) Factory(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "factory")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Factory is a free data retrieval call binding the contract method 0xc45a0155.
//
// Solidity: function factory() view returns(address)
func (_Bonding *BondingSession) Factory() (common.Address, error) {
	return _Bonding.Contract.Factory(&_Bonding.CallOpts)
}

// Factory is a free data retrieval call binding the contract method 0xc45a0155.
//
// Solidity: function factory() view returns(address)
func (_Bonding *BondingCallerSession) Factory() (common.Address, error) {
	return _Bonding.Contract.Factory(&_Bonding.CallOpts)
}

// Fee is a free data retrieval call binding the contract method 0xddca3f43.
//
// Solidity: function fee() view returns(uint256)
func (_Bonding *BondingCaller) Fee(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "fee")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// Fee is a free data retrieval call binding the contract method 0xddca3f43.
//
// Solidity: function fee() view returns(uint256)
func (_Bonding *BondingSession) Fee() (*big.Int, error) {
	return _Bonding.Contract.Fee(&_Bonding.CallOpts)
}

// Fee is a free data retrieval call binding the contract method 0xddca3f43.
//
// Solidity: function fee() view returns(uint256)
func (_Bonding *BondingCallerSession) Fee() (*big.Int, error) {
	return _Bonding.Contract.Fee(&_Bonding.CallOpts)
}

// GetUniswapPairsLength is a free data retrieval call binding the contract method 0xbbfefbd5.
//
// Solidity: function getUniswapPairsLength() view returns(uint256)
func (_Bonding *BondingCaller) GetUniswapPairsLength(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "getUniswapPairsLength")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetUniswapPairsLength is a free data retrieval call binding the contract method 0xbbfefbd5.
//
// Solidity: function getUniswapPairsLength() view returns(uint256)
func (_Bonding *BondingSession) GetUniswapPairsLength() (*big.Int, error) {
	return _Bonding.Contract.GetUniswapPairsLength(&_Bonding.CallOpts)
}

// GetUniswapPairsLength is a free data retrieval call binding the contract method 0xbbfefbd5.
//
// Solidity: function getUniswapPairsLength() view returns(uint256)
func (_Bonding *BondingCallerSession) GetUniswapPairsLength() (*big.Int, error) {
	return _Bonding.Contract.GetUniswapPairsLength(&_Bonding.CallOpts)
}

// GetUserTokens is a free data retrieval call binding the contract method 0x519dc8d2.
//
// Solidity: function getUserTokens(address account) view returns(address[])
func (_Bonding *BondingCaller) GetUserTokens(opts *bind.CallOpts, account common.Address) ([]common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "getUserTokens", account)

	if err != nil {
		return *new([]common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new([]common.Address)).(*[]common.Address)

	return out0, err

}

// GetUserTokens is a free data retrieval call binding the contract method 0x519dc8d2.
//
// Solidity: function getUserTokens(address account) view returns(address[])
func (_Bonding *BondingSession) GetUserTokens(account common.Address) ([]common.Address, error) {
	return _Bonding.Contract.GetUserTokens(&_Bonding.CallOpts, account)
}

// GetUserTokens is a free data retrieval call binding the contract method 0x519dc8d2.
//
// Solidity: function getUserTokens(address account) view returns(address[])
func (_Bonding *BondingCallerSession) GetUserTokens(account common.Address) ([]common.Address, error) {
	return _Bonding.Contract.GetUserTokens(&_Bonding.CallOpts, account)
}

// GradThreshold is a free data retrieval call binding the contract method 0x6edd12e0.
//
// Solidity: function gradThreshold() view returns(uint256)
func (_Bonding *BondingCaller) GradThreshold(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "gradThreshold")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GradThreshold is a free data retrieval call binding the contract method 0x6edd12e0.
//
// Solidity: function gradThreshold() view returns(uint256)
func (_Bonding *BondingSession) GradThreshold() (*big.Int, error) {
	return _Bonding.Contract.GradThreshold(&_Bonding.CallOpts)
}

// GradThreshold is a free data retrieval call binding the contract method 0x6edd12e0.
//
// Solidity: function gradThreshold() view returns(uint256)
func (_Bonding *BondingCallerSession) GradThreshold() (*big.Int, error) {
	return _Bonding.Contract.GradThreshold(&_Bonding.CallOpts)
}

// InitialSupply is a free data retrieval call binding the contract method 0x378dc3dc.
//
// Solidity: function initialSupply() view returns(uint256)
func (_Bonding *BondingCaller) InitialSupply(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "initialSupply")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// InitialSupply is a free data retrieval call binding the contract method 0x378dc3dc.
//
// Solidity: function initialSupply() view returns(uint256)
func (_Bonding *BondingSession) InitialSupply() (*big.Int, error) {
	return _Bonding.Contract.InitialSupply(&_Bonding.CallOpts)
}

// InitialSupply is a free data retrieval call binding the contract method 0x378dc3dc.
//
// Solidity: function initialSupply() view returns(uint256)
func (_Bonding *BondingCallerSession) InitialSupply() (*big.Int, error) {
	return _Bonding.Contract.InitialSupply(&_Bonding.CallOpts)
}

// LpLocker is a free data retrieval call binding the contract method 0x03fc2013.
//
// Solidity: function lpLocker() view returns(address)
func (_Bonding *BondingCaller) LpLocker(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "lpLocker")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// LpLocker is a free data retrieval call binding the contract method 0x03fc2013.
//
// Solidity: function lpLocker() view returns(address)
func (_Bonding *BondingSession) LpLocker() (common.Address, error) {
	return _Bonding.Contract.LpLocker(&_Bonding.CallOpts)
}

// LpLocker is a free data retrieval call binding the contract method 0x03fc2013.
//
// Solidity: function lpLocker() view returns(address)
func (_Bonding *BondingCallerSession) LpLocker() (common.Address, error) {
	return _Bonding.Contract.LpLocker(&_Bonding.CallOpts)
}

// MaxTx is a free data retrieval call binding the contract method 0x7437681e.
//
// Solidity: function maxTx() view returns(uint256)
func (_Bonding *BondingCaller) MaxTx(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "maxTx")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// MaxTx is a free data retrieval call binding the contract method 0x7437681e.
//
// Solidity: function maxTx() view returns(uint256)
func (_Bonding *BondingSession) MaxTx() (*big.Int, error) {
	return _Bonding.Contract.MaxTx(&_Bonding.CallOpts)
}

// MaxTx is a free data retrieval call binding the contract method 0x7437681e.
//
// Solidity: function maxTx() view returns(uint256)
func (_Bonding *BondingCallerSession) MaxTx() (*big.Int, error) {
	return _Bonding.Contract.MaxTx(&_Bonding.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Bonding *BondingCaller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Bonding *BondingSession) Owner() (common.Address, error) {
	return _Bonding.Contract.Owner(&_Bonding.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Bonding *BondingCallerSession) Owner() (common.Address, error) {
	return _Bonding.Contract.Owner(&_Bonding.CallOpts)
}

// Profile is a free data retrieval call binding the contract method 0x9dd9d0fd.
//
// Solidity: function profile(address ) view returns(address user)
func (_Bonding *BondingCaller) Profile(opts *bind.CallOpts, arg0 common.Address) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "profile", arg0)

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Profile is a free data retrieval call binding the contract method 0x9dd9d0fd.
//
// Solidity: function profile(address ) view returns(address user)
func (_Bonding *BondingSession) Profile(arg0 common.Address) (common.Address, error) {
	return _Bonding.Contract.Profile(&_Bonding.CallOpts, arg0)
}

// Profile is a free data retrieval call binding the contract method 0x9dd9d0fd.
//
// Solidity: function profile(address ) view returns(address user)
func (_Bonding *BondingCallerSession) Profile(arg0 common.Address) (common.Address, error) {
	return _Bonding.Contract.Profile(&_Bonding.CallOpts, arg0)
}

// Profiles is a free data retrieval call binding the contract method 0xc36fe3d6.
//
// Solidity: function profiles(uint256 ) view returns(address)
func (_Bonding *BondingCaller) Profiles(opts *bind.CallOpts, arg0 *big.Int) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "profiles", arg0)

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Profiles is a free data retrieval call binding the contract method 0xc36fe3d6.
//
// Solidity: function profiles(uint256 ) view returns(address)
func (_Bonding *BondingSession) Profiles(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.Profiles(&_Bonding.CallOpts, arg0)
}

// Profiles is a free data retrieval call binding the contract method 0xc36fe3d6.
//
// Solidity: function profiles(uint256 ) view returns(address)
func (_Bonding *BondingCallerSession) Profiles(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.Profiles(&_Bonding.CallOpts, arg0)
}

// Router is a free data retrieval call binding the contract method 0xf887ea40.
//
// Solidity: function router() view returns(address)
func (_Bonding *BondingCaller) Router(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "router")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Router is a free data retrieval call binding the contract method 0xf887ea40.
//
// Solidity: function router() view returns(address)
func (_Bonding *BondingSession) Router() (common.Address, error) {
	return _Bonding.Contract.Router(&_Bonding.CallOpts)
}

// Router is a free data retrieval call binding the contract method 0xf887ea40.
//
// Solidity: function router() view returns(address)
func (_Bonding *BondingCallerSession) Router() (common.Address, error) {
	return _Bonding.Contract.Router(&_Bonding.CallOpts)
}

// TokenInfo is a free data retrieval call binding the contract method 0xf5dab711.
//
// Solidity: function tokenInfo(address ) view returns(address creator, address token, address pair, address nftAddress, (address,string,string,string,uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256) data, string description, string image, string website, string twitter, string telegram, bool trading, bool tradingOnUniswap, address uniswapV2Pair)
func (_Bonding *BondingCaller) TokenInfo(opts *bind.CallOpts, arg0 common.Address) (struct {
	Creator          common.Address
	Token            common.Address
	Pair             common.Address
	NftAddress       common.Address
	Data             BondingData
	Description      string
	Image            string
	Website          string
	Twitter          string
	Telegram         string
	Trading          bool
	TradingOnUniswap bool
	UniswapV2Pair    common.Address
}, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "tokenInfo", arg0)

	outstruct := new(struct {
		Creator          common.Address
		Token            common.Address
		Pair             common.Address
		NftAddress       common.Address
		Data             BondingData
		Description      string
		Image            string
		Website          string
		Twitter          string
		Telegram         string
		Trading          bool
		TradingOnUniswap bool
		UniswapV2Pair    common.Address
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.Creator = *abi.ConvertType(out[0], new(common.Address)).(*common.Address)
	outstruct.Token = *abi.ConvertType(out[1], new(common.Address)).(*common.Address)
	outstruct.Pair = *abi.ConvertType(out[2], new(common.Address)).(*common.Address)
	outstruct.NftAddress = *abi.ConvertType(out[3], new(common.Address)).(*common.Address)
	outstruct.Data = *abi.ConvertType(out[4], new(BondingData)).(*BondingData)
	outstruct.Description = *abi.ConvertType(out[5], new(string)).(*string)
	outstruct.Image = *abi.ConvertType(out[6], new(string)).(*string)
	outstruct.Website = *abi.ConvertType(out[7], new(string)).(*string)
	outstruct.Twitter = *abi.ConvertType(out[8], new(string)).(*string)
	outstruct.Telegram = *abi.ConvertType(out[9], new(string)).(*string)
	outstruct.Trading = *abi.ConvertType(out[10], new(bool)).(*bool)
	outstruct.TradingOnUniswap = *abi.ConvertType(out[11], new(bool)).(*bool)
	outstruct.UniswapV2Pair = *abi.ConvertType(out[12], new(common.Address)).(*common.Address)

	return *outstruct, err

}

// TokenInfo is a free data retrieval call binding the contract method 0xf5dab711.
//
// Solidity: function tokenInfo(address ) view returns(address creator, address token, address pair, address nftAddress, (address,string,string,string,uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256) data, string description, string image, string website, string twitter, string telegram, bool trading, bool tradingOnUniswap, address uniswapV2Pair)
func (_Bonding *BondingSession) TokenInfo(arg0 common.Address) (struct {
	Creator          common.Address
	Token            common.Address
	Pair             common.Address
	NftAddress       common.Address
	Data             BondingData
	Description      string
	Image            string
	Website          string
	Twitter          string
	Telegram         string
	Trading          bool
	TradingOnUniswap bool
	UniswapV2Pair    common.Address
}, error) {
	return _Bonding.Contract.TokenInfo(&_Bonding.CallOpts, arg0)
}

// TokenInfo is a free data retrieval call binding the contract method 0xf5dab711.
//
// Solidity: function tokenInfo(address ) view returns(address creator, address token, address pair, address nftAddress, (address,string,string,string,uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256) data, string description, string image, string website, string twitter, string telegram, bool trading, bool tradingOnUniswap, address uniswapV2Pair)
func (_Bonding *BondingCallerSession) TokenInfo(arg0 common.Address) (struct {
	Creator          common.Address
	Token            common.Address
	Pair             common.Address
	NftAddress       common.Address
	Data             BondingData
	Description      string
	Image            string
	Website          string
	Twitter          string
	Telegram         string
	Trading          bool
	TradingOnUniswap bool
	UniswapV2Pair    common.Address
}, error) {
	return _Bonding.Contract.TokenInfo(&_Bonding.CallOpts, arg0)
}

// TokenInfos is a free data retrieval call binding the contract method 0x7c13774b.
//
// Solidity: function tokenInfos(uint256 ) view returns(address)
func (_Bonding *BondingCaller) TokenInfos(opts *bind.CallOpts, arg0 *big.Int) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "tokenInfos", arg0)

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// TokenInfos is a free data retrieval call binding the contract method 0x7c13774b.
//
// Solidity: function tokenInfos(uint256 ) view returns(address)
func (_Bonding *BondingSession) TokenInfos(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.TokenInfos(&_Bonding.CallOpts, arg0)
}

// TokenInfos is a free data retrieval call binding the contract method 0x7c13774b.
//
// Solidity: function tokenInfos(uint256 ) view returns(address)
func (_Bonding *BondingCallerSession) TokenInfos(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.TokenInfos(&_Bonding.CallOpts, arg0)
}

// UniswapPairs is a free data retrieval call binding the contract method 0x8397e993.
//
// Solidity: function uniswapPairs(uint256 ) view returns(address)
func (_Bonding *BondingCaller) UniswapPairs(opts *bind.CallOpts, arg0 *big.Int) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "uniswapPairs", arg0)

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// UniswapPairs is a free data retrieval call binding the contract method 0x8397e993.
//
// Solidity: function uniswapPairs(uint256 ) view returns(address)
func (_Bonding *BondingSession) UniswapPairs(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.UniswapPairs(&_Bonding.CallOpts, arg0)
}

// UniswapPairs is a free data retrieval call binding the contract method 0x8397e993.
//
// Solidity: function uniswapPairs(uint256 ) view returns(address)
func (_Bonding *BondingCallerSession) UniswapPairs(arg0 *big.Int) (common.Address, error) {
	return _Bonding.Contract.UniswapPairs(&_Bonding.CallOpts, arg0)
}

// UniswapRouter is a free data retrieval call binding the contract method 0x735de9f7.
//
// Solidity: function uniswapRouter() view returns(address)
func (_Bonding *BondingCaller) UniswapRouter(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Bonding.contract.Call(opts, &out, "uniswapRouter")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// UniswapRouter is a free data retrieval call binding the contract method 0x735de9f7.
//
// Solidity: function uniswapRouter() view returns(address)
func (_Bonding *BondingSession) UniswapRouter() (common.Address, error) {
	return _Bonding.Contract.UniswapRouter(&_Bonding.CallOpts)
}

// UniswapRouter is a free data retrieval call binding the contract method 0x735de9f7.
//
// Solidity: function uniswapRouter() view returns(address)
func (_Bonding *BondingCallerSession) UniswapRouter() (common.Address, error) {
	return _Bonding.Contract.UniswapRouter(&_Bonding.CallOpts)
}

// Buy is a paid mutator transaction binding the contract method 0x7deb6025.
//
// Solidity: function buy(uint256 amountIn, address tokenAddress) payable returns(bool)
func (_Bonding *BondingTransactor) Buy(opts *bind.TransactOpts, amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "buy", amountIn, tokenAddress)
}

// Buy is a paid mutator transaction binding the contract method 0x7deb6025.
//
// Solidity: function buy(uint256 amountIn, address tokenAddress) payable returns(bool)
func (_Bonding *BondingSession) Buy(amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Buy(&_Bonding.TransactOpts, amountIn, tokenAddress)
}

// Buy is a paid mutator transaction binding the contract method 0x7deb6025.
//
// Solidity: function buy(uint256 amountIn, address tokenAddress) payable returns(bool)
func (_Bonding *BondingTransactorSession) Buy(amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Buy(&_Bonding.TransactOpts, amountIn, tokenAddress)
}

// Initialize is a paid mutator transaction binding the contract method 0x85eea923.
//
// Solidity: function initialize(address factory_, address router_, address feeTo_, uint256 fee_, uint256 initialSupply_, uint256 assetRate_, uint256 maxTx_, uint256 gradThreshold_, address uniswapV2Router_, address lpLocker_) returns()
func (_Bonding *BondingTransactor) Initialize(opts *bind.TransactOpts, factory_ common.Address, router_ common.Address, feeTo_ common.Address, fee_ *big.Int, initialSupply_ *big.Int, assetRate_ *big.Int, maxTx_ *big.Int, gradThreshold_ *big.Int, uniswapV2Router_ common.Address, lpLocker_ common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "initialize", factory_, router_, feeTo_, fee_, initialSupply_, assetRate_, maxTx_, gradThreshold_, uniswapV2Router_, lpLocker_)
}

// Initialize is a paid mutator transaction binding the contract method 0x85eea923.
//
// Solidity: function initialize(address factory_, address router_, address feeTo_, uint256 fee_, uint256 initialSupply_, uint256 assetRate_, uint256 maxTx_, uint256 gradThreshold_, address uniswapV2Router_, address lpLocker_) returns()
func (_Bonding *BondingSession) Initialize(factory_ common.Address, router_ common.Address, feeTo_ common.Address, fee_ *big.Int, initialSupply_ *big.Int, assetRate_ *big.Int, maxTx_ *big.Int, gradThreshold_ *big.Int, uniswapV2Router_ common.Address, lpLocker_ common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Initialize(&_Bonding.TransactOpts, factory_, router_, feeTo_, fee_, initialSupply_, assetRate_, maxTx_, gradThreshold_, uniswapV2Router_, lpLocker_)
}

// Initialize is a paid mutator transaction binding the contract method 0x85eea923.
//
// Solidity: function initialize(address factory_, address router_, address feeTo_, uint256 fee_, uint256 initialSupply_, uint256 assetRate_, uint256 maxTx_, uint256 gradThreshold_, address uniswapV2Router_, address lpLocker_) returns()
func (_Bonding *BondingTransactorSession) Initialize(factory_ common.Address, router_ common.Address, feeTo_ common.Address, fee_ *big.Int, initialSupply_ *big.Int, assetRate_ *big.Int, maxTx_ *big.Int, gradThreshold_ *big.Int, uniswapV2Router_ common.Address, lpLocker_ common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Initialize(&_Bonding.TransactOpts, factory_, router_, feeTo_, fee_, initialSupply_, assetRate_, maxTx_, gradThreshold_, uniswapV2Router_, lpLocker_)
}

// Launch is a paid mutator transaction binding the contract method 0x3f1250f7.
//
// Solidity: function launch(string _name, string _ticker, string desc, string img, string[3] urls, uint256 purchaseAmount, address nftAddress) payable returns(address, address, uint256)
func (_Bonding *BondingTransactor) Launch(opts *bind.TransactOpts, _name string, _ticker string, desc string, img string, urls [3]string, purchaseAmount *big.Int, nftAddress common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "launch", _name, _ticker, desc, img, urls, purchaseAmount, nftAddress)
}

// Launch is a paid mutator transaction binding the contract method 0x3f1250f7.
//
// Solidity: function launch(string _name, string _ticker, string desc, string img, string[3] urls, uint256 purchaseAmount, address nftAddress) payable returns(address, address, uint256)
func (_Bonding *BondingSession) Launch(_name string, _ticker string, desc string, img string, urls [3]string, purchaseAmount *big.Int, nftAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Launch(&_Bonding.TransactOpts, _name, _ticker, desc, img, urls, purchaseAmount, nftAddress)
}

// Launch is a paid mutator transaction binding the contract method 0x3f1250f7.
//
// Solidity: function launch(string _name, string _ticker, string desc, string img, string[3] urls, uint256 purchaseAmount, address nftAddress) payable returns(address, address, uint256)
func (_Bonding *BondingTransactorSession) Launch(_name string, _ticker string, desc string, img string, urls [3]string, purchaseAmount *big.Int, nftAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Launch(&_Bonding.TransactOpts, _name, _ticker, desc, img, urls, purchaseAmount, nftAddress)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Bonding *BondingTransactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Bonding *BondingSession) RenounceOwnership() (*types.Transaction, error) {
	return _Bonding.Contract.RenounceOwnership(&_Bonding.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Bonding *BondingTransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _Bonding.Contract.RenounceOwnership(&_Bonding.TransactOpts)
}

// Sell is a paid mutator transaction binding the contract method 0x4189a68e.
//
// Solidity: function sell(uint256 amountIn, address tokenAddress) returns(bool)
func (_Bonding *BondingTransactor) Sell(opts *bind.TransactOpts, amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "sell", amountIn, tokenAddress)
}

// Sell is a paid mutator transaction binding the contract method 0x4189a68e.
//
// Solidity: function sell(uint256 amountIn, address tokenAddress) returns(bool)
func (_Bonding *BondingSession) Sell(amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Sell(&_Bonding.TransactOpts, amountIn, tokenAddress)
}

// Sell is a paid mutator transaction binding the contract method 0x4189a68e.
//
// Solidity: function sell(uint256 amountIn, address tokenAddress) returns(bool)
func (_Bonding *BondingTransactorSession) Sell(amountIn *big.Int, tokenAddress common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.Sell(&_Bonding.TransactOpts, amountIn, tokenAddress)
}

// SetAssetRate is a paid mutator transaction binding the contract method 0xcc489688.
//
// Solidity: function setAssetRate(uint256 newRate) returns()
func (_Bonding *BondingTransactor) SetAssetRate(opts *bind.TransactOpts, newRate *big.Int) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setAssetRate", newRate)
}

// SetAssetRate is a paid mutator transaction binding the contract method 0xcc489688.
//
// Solidity: function setAssetRate(uint256 newRate) returns()
func (_Bonding *BondingSession) SetAssetRate(newRate *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetAssetRate(&_Bonding.TransactOpts, newRate)
}

// SetAssetRate is a paid mutator transaction binding the contract method 0xcc489688.
//
// Solidity: function setAssetRate(uint256 newRate) returns()
func (_Bonding *BondingTransactorSession) SetAssetRate(newRate *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetAssetRate(&_Bonding.TransactOpts, newRate)
}

// SetFee is a paid mutator transaction binding the contract method 0xb4f2e8b8.
//
// Solidity: function setFee(uint256 newFee, address newFeeTo) returns()
func (_Bonding *BondingTransactor) SetFee(opts *bind.TransactOpts, newFee *big.Int, newFeeTo common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setFee", newFee, newFeeTo)
}

// SetFee is a paid mutator transaction binding the contract method 0xb4f2e8b8.
//
// Solidity: function setFee(uint256 newFee, address newFeeTo) returns()
func (_Bonding *BondingSession) SetFee(newFee *big.Int, newFeeTo common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.SetFee(&_Bonding.TransactOpts, newFee, newFeeTo)
}

// SetFee is a paid mutator transaction binding the contract method 0xb4f2e8b8.
//
// Solidity: function setFee(uint256 newFee, address newFeeTo) returns()
func (_Bonding *BondingTransactorSession) SetFee(newFee *big.Int, newFeeTo common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.SetFee(&_Bonding.TransactOpts, newFee, newFeeTo)
}

// SetGradThreshold is a paid mutator transaction binding the contract method 0x09c8962c.
//
// Solidity: function setGradThreshold(uint256 newThreshold) returns()
func (_Bonding *BondingTransactor) SetGradThreshold(opts *bind.TransactOpts, newThreshold *big.Int) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setGradThreshold", newThreshold)
}

// SetGradThreshold is a paid mutator transaction binding the contract method 0x09c8962c.
//
// Solidity: function setGradThreshold(uint256 newThreshold) returns()
func (_Bonding *BondingSession) SetGradThreshold(newThreshold *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetGradThreshold(&_Bonding.TransactOpts, newThreshold)
}

// SetGradThreshold is a paid mutator transaction binding the contract method 0x09c8962c.
//
// Solidity: function setGradThreshold(uint256 newThreshold) returns()
func (_Bonding *BondingTransactorSession) SetGradThreshold(newThreshold *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetGradThreshold(&_Bonding.TransactOpts, newThreshold)
}

// SetInitialSupply is a paid mutator transaction binding the contract method 0x61402596.
//
// Solidity: function setInitialSupply(uint256 newSupply) returns()
func (_Bonding *BondingTransactor) SetInitialSupply(opts *bind.TransactOpts, newSupply *big.Int) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setInitialSupply", newSupply)
}

// SetInitialSupply is a paid mutator transaction binding the contract method 0x61402596.
//
// Solidity: function setInitialSupply(uint256 newSupply) returns()
func (_Bonding *BondingSession) SetInitialSupply(newSupply *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetInitialSupply(&_Bonding.TransactOpts, newSupply)
}

// SetInitialSupply is a paid mutator transaction binding the contract method 0x61402596.
//
// Solidity: function setInitialSupply(uint256 newSupply) returns()
func (_Bonding *BondingTransactorSession) SetInitialSupply(newSupply *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetInitialSupply(&_Bonding.TransactOpts, newSupply)
}

// SetMaxTx is a paid mutator transaction binding the contract method 0xbc337182.
//
// Solidity: function setMaxTx(uint256 maxTx_) returns()
func (_Bonding *BondingTransactor) SetMaxTx(opts *bind.TransactOpts, maxTx_ *big.Int) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setMaxTx", maxTx_)
}

// SetMaxTx is a paid mutator transaction binding the contract method 0xbc337182.
//
// Solidity: function setMaxTx(uint256 maxTx_) returns()
func (_Bonding *BondingSession) SetMaxTx(maxTx_ *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetMaxTx(&_Bonding.TransactOpts, maxTx_)
}

// SetMaxTx is a paid mutator transaction binding the contract method 0xbc337182.
//
// Solidity: function setMaxTx(uint256 maxTx_) returns()
func (_Bonding *BondingTransactorSession) SetMaxTx(maxTx_ *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.SetMaxTx(&_Bonding.TransactOpts, maxTx_)
}

// SetUniswapRouter is a paid mutator transaction binding the contract method 0xbea9849e.
//
// Solidity: function setUniswapRouter(address newRouter) returns()
func (_Bonding *BondingTransactor) SetUniswapRouter(opts *bind.TransactOpts, newRouter common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "setUniswapRouter", newRouter)
}

// SetUniswapRouter is a paid mutator transaction binding the contract method 0xbea9849e.
//
// Solidity: function setUniswapRouter(address newRouter) returns()
func (_Bonding *BondingSession) SetUniswapRouter(newRouter common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.SetUniswapRouter(&_Bonding.TransactOpts, newRouter)
}

// SetUniswapRouter is a paid mutator transaction binding the contract method 0xbea9849e.
//
// Solidity: function setUniswapRouter(address newRouter) returns()
func (_Bonding *BondingTransactorSession) SetUniswapRouter(newRouter common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.SetUniswapRouter(&_Bonding.TransactOpts, newRouter)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Bonding *BondingTransactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Bonding *BondingSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.TransferOwnership(&_Bonding.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Bonding *BondingTransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Bonding.Contract.TransferOwnership(&_Bonding.TransactOpts, newOwner)
}

// TransferToken is a paid mutator transaction binding the contract method 0xf5537ede.
//
// Solidity: function transferToken(address token, address recipient, uint256 amount) returns()
func (_Bonding *BondingTransactor) TransferToken(opts *bind.TransactOpts, token common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _Bonding.contract.Transact(opts, "transferToken", token, recipient, amount)
}

// TransferToken is a paid mutator transaction binding the contract method 0xf5537ede.
//
// Solidity: function transferToken(address token, address recipient, uint256 amount) returns()
func (_Bonding *BondingSession) TransferToken(token common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.TransferToken(&_Bonding.TransactOpts, token, recipient, amount)
}

// TransferToken is a paid mutator transaction binding the contract method 0xf5537ede.
//
// Solidity: function transferToken(address token, address recipient, uint256 amount) returns()
func (_Bonding *BondingTransactorSession) TransferToken(token common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _Bonding.Contract.TransferToken(&_Bonding.TransactOpts, token, recipient, amount)
}

// BondingGraduatedIterator is returned from FilterGraduated and is used to iterate over the raw logs and unpacked data for Graduated events raised by the Bonding contract.
type BondingGraduatedIterator struct {
	Event *BondingGraduated // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingGraduatedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingGraduated)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingGraduated)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingGraduatedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingGraduatedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingGraduated represents a Graduated event raised by the Bonding contract.
type BondingGraduated struct {
	Token     common.Address
	Univ2Pair common.Address
	Raw       types.Log // Blockchain specific contextual infos
}

// FilterGraduated is a free log retrieval operation binding the contract event 0x381d54fa425631e6266af114239150fae1d5db67bb65b4fa9ecc65013107e07e.
//
// Solidity: event Graduated(address indexed token, address indexed univ2Pair)
func (_Bonding *BondingFilterer) FilterGraduated(opts *bind.FilterOpts, token []common.Address, univ2Pair []common.Address) (*BondingGraduatedIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var univ2PairRule []interface{}
	for _, univ2PairItem := range univ2Pair {
		univ2PairRule = append(univ2PairRule, univ2PairItem)
	}

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "Graduated", tokenRule, univ2PairRule)
	if err != nil {
		return nil, err
	}
	return &BondingGraduatedIterator{contract: _Bonding.contract, event: "Graduated", logs: logs, sub: sub}, nil
}

// WatchGraduated is a free log subscription operation binding the contract event 0x381d54fa425631e6266af114239150fae1d5db67bb65b4fa9ecc65013107e07e.
//
// Solidity: event Graduated(address indexed token, address indexed univ2Pair)
func (_Bonding *BondingFilterer) WatchGraduated(opts *bind.WatchOpts, sink chan<- *BondingGraduated, token []common.Address, univ2Pair []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var univ2PairRule []interface{}
	for _, univ2PairItem := range univ2Pair {
		univ2PairRule = append(univ2PairRule, univ2PairItem)
	}

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "Graduated", tokenRule, univ2PairRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingGraduated)
				if err := _Bonding.contract.UnpackLog(event, "Graduated", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseGraduated is a log parse operation binding the contract event 0x381d54fa425631e6266af114239150fae1d5db67bb65b4fa9ecc65013107e07e.
//
// Solidity: event Graduated(address indexed token, address indexed univ2Pair)
func (_Bonding *BondingFilterer) ParseGraduated(log types.Log) (*BondingGraduated, error) {
	event := new(BondingGraduated)
	if err := _Bonding.contract.UnpackLog(event, "Graduated", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// BondingInitializedIterator is returned from FilterInitialized and is used to iterate over the raw logs and unpacked data for Initialized events raised by the Bonding contract.
type BondingInitializedIterator struct {
	Event *BondingInitialized // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingInitializedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingInitialized)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingInitialized)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingInitializedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingInitializedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingInitialized represents a Initialized event raised by the Bonding contract.
type BondingInitialized struct {
	Version uint64
	Raw     types.Log // Blockchain specific contextual infos
}

// FilterInitialized is a free log retrieval operation binding the contract event 0xc7f505b2f371ae2175ee4913f4499e1f2633a7b5936321eed1cdaeb6115181d2.
//
// Solidity: event Initialized(uint64 version)
func (_Bonding *BondingFilterer) FilterInitialized(opts *bind.FilterOpts) (*BondingInitializedIterator, error) {

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "Initialized")
	if err != nil {
		return nil, err
	}
	return &BondingInitializedIterator{contract: _Bonding.contract, event: "Initialized", logs: logs, sub: sub}, nil
}

// WatchInitialized is a free log subscription operation binding the contract event 0xc7f505b2f371ae2175ee4913f4499e1f2633a7b5936321eed1cdaeb6115181d2.
//
// Solidity: event Initialized(uint64 version)
func (_Bonding *BondingFilterer) WatchInitialized(opts *bind.WatchOpts, sink chan<- *BondingInitialized) (event.Subscription, error) {

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "Initialized")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingInitialized)
				if err := _Bonding.contract.UnpackLog(event, "Initialized", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseInitialized is a log parse operation binding the contract event 0xc7f505b2f371ae2175ee4913f4499e1f2633a7b5936321eed1cdaeb6115181d2.
//
// Solidity: event Initialized(uint64 version)
func (_Bonding *BondingFilterer) ParseInitialized(log types.Log) (*BondingInitialized, error) {
	event := new(BondingInitialized)
	if err := _Bonding.contract.UnpackLog(event, "Initialized", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// BondingLaunchedIterator is returned from FilterLaunched and is used to iterate over the raw logs and unpacked data for Launched events raised by the Bonding contract.
type BondingLaunchedIterator struct {
	Event *BondingLaunched // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingLaunchedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingLaunched)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingLaunched)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingLaunchedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingLaunchedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingLaunched represents a Launched event raised by the Bonding contract.
type BondingLaunched struct {
	Token common.Address
	Pair  common.Address
	Arg2  *big.Int
	Raw   types.Log // Blockchain specific contextual infos
}

// FilterLaunched is a free log retrieval operation binding the contract event 0x714aa39317ad9a7a7a99db52b44490da5d068a0b2710fffb1a1282ad3cadae1f.
//
// Solidity: event Launched(address indexed token, address indexed pair, uint256 arg2)
func (_Bonding *BondingFilterer) FilterLaunched(opts *bind.FilterOpts, token []common.Address, pair []common.Address) (*BondingLaunchedIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var pairRule []interface{}
	for _, pairItem := range pair {
		pairRule = append(pairRule, pairItem)
	}

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "Launched", tokenRule, pairRule)
	if err != nil {
		return nil, err
	}
	return &BondingLaunchedIterator{contract: _Bonding.contract, event: "Launched", logs: logs, sub: sub}, nil
}

// WatchLaunched is a free log subscription operation binding the contract event 0x714aa39317ad9a7a7a99db52b44490da5d068a0b2710fffb1a1282ad3cadae1f.
//
// Solidity: event Launched(address indexed token, address indexed pair, uint256 arg2)
func (_Bonding *BondingFilterer) WatchLaunched(opts *bind.WatchOpts, sink chan<- *BondingLaunched, token []common.Address, pair []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var pairRule []interface{}
	for _, pairItem := range pair {
		pairRule = append(pairRule, pairItem)
	}

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "Launched", tokenRule, pairRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingLaunched)
				if err := _Bonding.contract.UnpackLog(event, "Launched", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseLaunched is a log parse operation binding the contract event 0x714aa39317ad9a7a7a99db52b44490da5d068a0b2710fffb1a1282ad3cadae1f.
//
// Solidity: event Launched(address indexed token, address indexed pair, uint256 arg2)
func (_Bonding *BondingFilterer) ParseLaunched(log types.Log) (*BondingLaunched, error) {
	event := new(BondingLaunched)
	if err := _Bonding.contract.UnpackLog(event, "Launched", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// BondingOwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the Bonding contract.
type BondingOwnershipTransferredIterator struct {
	Event *BondingOwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingOwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingOwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingOwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingOwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingOwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingOwnershipTransferred represents a OwnershipTransferred event raised by the Bonding contract.
type BondingOwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Bonding *BondingFilterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*BondingOwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &BondingOwnershipTransferredIterator{contract: _Bonding.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Bonding *BondingFilterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *BondingOwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingOwnershipTransferred)
				if err := _Bonding.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Bonding *BondingFilterer) ParseOwnershipTransferred(log types.Log) (*BondingOwnershipTransferred, error) {
	event := new(BondingOwnershipTransferred)
	if err := _Bonding.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// BondingSwapIterator is returned from FilterSwap and is used to iterate over the raw logs and unpacked data for Swap events raised by the Bonding contract.
type BondingSwapIterator struct {
	Event *BondingSwap // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingSwapIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingSwap)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingSwap)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingSwapIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingSwapIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingSwap represents a Swap event raised by the Bonding contract.
type BondingSwap struct {
	Sender     common.Address
	Token      common.Address
	Amount0In  *big.Int
	Amount0Out *big.Int
	Amount1In  *big.Int
	Amount1Out *big.Int
	Reserve0   *big.Int
	Reserve1   *big.Int
	Volume     *big.Int
	Volume24H  *big.Int
	Raw        types.Log // Blockchain specific contextual infos
}

// FilterSwap is a free log retrieval operation binding the contract event 0x3fe84e6df58344329a18c304c0110e2a518d8c1dfce228cd1f78d11c59bb648c.
//
// Solidity: event Swap(address indexed sender, address indexed token, uint256 amount0In, uint256 amount0Out, uint256 amount1In, uint256 amount1Out, uint256 reserve0, uint256 reserve1, uint256 volume, uint256 volume24H)
func (_Bonding *BondingFilterer) FilterSwap(opts *bind.FilterOpts, sender []common.Address, token []common.Address) (*BondingSwapIterator, error) {

	var senderRule []interface{}
	for _, senderItem := range sender {
		senderRule = append(senderRule, senderItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "Swap", senderRule, tokenRule)
	if err != nil {
		return nil, err
	}
	return &BondingSwapIterator{contract: _Bonding.contract, event: "Swap", logs: logs, sub: sub}, nil
}

// WatchSwap is a free log subscription operation binding the contract event 0x3fe84e6df58344329a18c304c0110e2a518d8c1dfce228cd1f78d11c59bb648c.
//
// Solidity: event Swap(address indexed sender, address indexed token, uint256 amount0In, uint256 amount0Out, uint256 amount1In, uint256 amount1Out, uint256 reserve0, uint256 reserve1, uint256 volume, uint256 volume24H)
func (_Bonding *BondingFilterer) WatchSwap(opts *bind.WatchOpts, sink chan<- *BondingSwap, sender []common.Address, token []common.Address) (event.Subscription, error) {

	var senderRule []interface{}
	for _, senderItem := range sender {
		senderRule = append(senderRule, senderItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "Swap", senderRule, tokenRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingSwap)
				if err := _Bonding.contract.UnpackLog(event, "Swap", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseSwap is a log parse operation binding the contract event 0x3fe84e6df58344329a18c304c0110e2a518d8c1dfce228cd1f78d11c59bb648c.
//
// Solidity: event Swap(address indexed sender, address indexed token, uint256 amount0In, uint256 amount0Out, uint256 amount1In, uint256 amount1Out, uint256 reserve0, uint256 reserve1, uint256 volume, uint256 volume24H)
func (_Bonding *BondingFilterer) ParseSwap(log types.Log) (*BondingSwap, error) {
	event := new(BondingSwap)
	if err := _Bonding.contract.UnpackLog(event, "Swap", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// BondingUniswapPoolCreatedIterator is returned from FilterUniswapPoolCreated and is used to iterate over the raw logs and unpacked data for UniswapPoolCreated events raised by the Bonding contract.
type BondingUniswapPoolCreatedIterator struct {
	Event *BondingUniswapPoolCreated // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *BondingUniswapPoolCreatedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(BondingUniswapPoolCreated)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(BondingUniswapPoolCreated)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *BondingUniswapPoolCreatedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *BondingUniswapPoolCreatedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// BondingUniswapPoolCreated represents a UniswapPoolCreated event raised by the Bonding contract.
type BondingUniswapPoolCreated struct {
	AddedPool common.Address
	Idx       *big.Int
	Raw       types.Log // Blockchain specific contextual infos
}

// FilterUniswapPoolCreated is a free log retrieval operation binding the contract event 0x8d53bf6c9d9f9be70816fc7584d94606d35c594142cfbea02724eca530f28181.
//
// Solidity: event UniswapPoolCreated(address addedPool, uint256 idx)
func (_Bonding *BondingFilterer) FilterUniswapPoolCreated(opts *bind.FilterOpts) (*BondingUniswapPoolCreatedIterator, error) {

	logs, sub, err := _Bonding.contract.FilterLogs(opts, "UniswapPoolCreated")
	if err != nil {
		return nil, err
	}
	return &BondingUniswapPoolCreatedIterator{contract: _Bonding.contract, event: "UniswapPoolCreated", logs: logs, sub: sub}, nil
}

// WatchUniswapPoolCreated is a free log subscription operation binding the contract event 0x8d53bf6c9d9f9be70816fc7584d94606d35c594142cfbea02724eca530f28181.
//
// Solidity: event UniswapPoolCreated(address addedPool, uint256 idx)
func (_Bonding *BondingFilterer) WatchUniswapPoolCreated(opts *bind.WatchOpts, sink chan<- *BondingUniswapPoolCreated) (event.Subscription, error) {

	logs, sub, err := _Bonding.contract.WatchLogs(opts, "UniswapPoolCreated")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(BondingUniswapPoolCreated)
				if err := _Bonding.contract.UnpackLog(event, "UniswapPoolCreated", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseUniswapPoolCreated is a log parse operation binding the contract event 0x8d53bf6c9d9f9be70816fc7584d94606d35c594142cfbea02724eca530f28181.
//
// Solidity: event UniswapPoolCreated(address addedPool, uint256 idx)
func (_Bonding *BondingFilterer) ParseUniswapPoolCreated(log types.Log) (*BondingUniswapPoolCreated, error) {
	event := new(BondingUniswapPoolCreated)
	if err := _Bonding.contract.UnpackLog(event, "UniswapPoolCreated", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
